// I will recommand you to use Arduino UNO as a programmer for your Atmega Chip

// Connections:
// RTC                     Ws2812b       SevenSegmentDisplay       PushButton to 3
// SDA  to A4(SDA)         DI to 6             CLK to 13            
// SCL  to A5(SCL)                             DIO to 12

// Created By Cyborg
//---------------------------------------------------------------------------------
#include <DS3232RTC.h>    
#include <DS3231.h>
#include <FastLED.h>
#include "SevenSegmentTM1637.h"

DS3232RTC myRTC;
DS3231  rtc(SDA, SCL);

const byte PIN_CLK = 13;  
const byte PIN_DIO = 12; 
#define LED_PIN     6
#define NUM_LEDS    12

SevenSegmentTM1637    display(PIN_CLK, PIN_DIO);
CRGB leds[NUM_LEDS];

float pressLength_milliSeconds = 0;
int buttonPin = 3;                                                
int val  = 0;   


int temp;
int segment = 0;
int light = 0;


void setup()
{
  Serial.begin(9600);
  myRTC.begin();
  rtc.begin();
  display.begin();      
  display.setBacklight(100);
  pinMode(buttonPin, INPUT_PULLUP); 
  FastLED.addLeds<WS2812, LED_PIN, GRB>(leds, NUM_LEDS);
  display.clear();
  
}

void loop()
{   
   while (digitalRead(buttonPin) == LOW ){ 
    delay(100);  
    pressLength_milliSeconds = pressLength_milliSeconds + 100;   
    Serial.print("ms = ");
    Serial.println(pressLength_milliSeconds);
  } 
   if (pressLength_milliSeconds >= 1500) {
    display.clear();
     led_clear();
    pressLength_milliSeconds = 0;
      
    } 

  else if(pressLength_milliSeconds >= 1000){
   display.clear();
   display.print("Torch");
    leds[0] = CRGB(255, 255, 255);
  FastLED.show();
  leds[1] = CRGB(255, 255, 255);
  FastLED.show();
  leds[2] = CRGB(255, 255, 255);
  FastLED.show();
  leds[3] = CRGB(255, 255, 255);
  FastLED.show();
  leds[4] = CRGB(255, 255, 255);
  FastLED.show();
  leds[5] = CRGB(255, 255, 255);
  FastLED.show();
  leds[6] = CRGB(255, 255, 255);
  FastLED.show();
  leds[7] = CRGB(255, 255, 255);
  FastLED.show();
  leds[8] = CRGB(0255, 255, 255);
  FastLED.show();
  leds[9] = CRGB(255, 255, 255);
  FastLED.show();
  leds[10] = CRGB(255, 255, 255);
  FastLED.show();
  leds[11] = CRGB(255, 255, 255);
  FastLED.show();
  }

else if (pressLength_milliSeconds >= 500){
  display.clear();
  led_clear();
   val++;
   light++;
   leds[light] = CRGB(0, 0, 255);
   FastLED.show();
   display.print(val);
     if (light == 11) {
      light = 0;  
     }
  delay(1000);
  }

  else if (pressLength_milliSeconds >= 0) {
     val = 0;
     light = 0;
    hourring();
    minutering();
    secondring();
    Serial.println(segment);
    segment++;
    if (segment == 1000) {
    display.clear();
     temp = rtc.getTemp();
     display.print(temp);
     delay(1000);
     char bufdmon[40]; 
    time_t t = myRTC.get();
    sprintf(bufdmon, "%.2d%.2d",
         day(t), month(t));
    Serial.println(bufdmon);
    display.print(bufdmon);
      segment = 0;
    } 
   }
   
}

void led_clear () {
  leds[0] = CRGB(0,0,0);
  FastLED.show();
  leds[1] = CRGB(0,0,0);
  FastLED.show();
  leds[2] = CRGB(0,0,0);
  FastLED.show();
  leds[3] = CRGB(0,0,0);
  FastLED.show();
  leds[4] = CRGB(0,0,0);
  FastLED.show();
  leds[5] = CRGB(0,0,0);
  FastLED.show();
  leds[6] = CRGB(0,0,0);
  FastLED.show();
  leds[7] = CRGB(0,0,0);
  FastLED.show();
  leds[8] = CRGB(0,0,0);
  FastLED.show();
  leds[9] = CRGB(0,0,0);
  FastLED.show();
  leds[10] = CRGB(0,0,0);
  FastLED.show();
  leds[11] = CRGB(0,0,0);
  FastLED.show();
}

void hourring() {
  char bufh[40];
  time_t t = myRTC.get();
  sprintf(bufh, "%.2d ",
        hour(t));
  Serial.print(bufh);
  if(hour(t) == 00) {
    leds[11] = CRGB(0, 0, 0);
  FastLED.show();
    leds[0] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 1) {
    leds[0] = CRGB(0, 0, 0);
  FastLED.show();
    leds[1] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 2) {
    leds[1] = CRGB(0, 0, 0);
  FastLED.show();
    leds[2] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 3) {
    leds[2] = CRGB(0, 0, 0);
  FastLED.show();
    leds[3] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 4) {
    leds[3] = CRGB(0, 0, 0);
  FastLED.show();
    leds[4] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 5) {
    leds[4] = CRGB(0, 0, 0);
  FastLED.show();
    leds[5] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 6) {
    leds[5] = CRGB(0, 0, 0);
  FastLED.show();
    leds[6] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 7) {
    leds[6] = CRGB(0, 0, 0);
  FastLED.show();
    leds[7] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 8) {
    leds[7] = CRGB(0, 0, 0);
  FastLED.show();
    leds[8] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 9) {
    leds[8] = CRGB(0, 0, 0);
  FastLED.show();
    leds[9] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 10) {
    leds[9] = CRGB(0, 0, 0);
  FastLED.show();
    leds[10] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 11) {
    leds[10] = CRGB(0, 0, 0);
  FastLED.show();
   leds[11] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 12) {
    leds[11] = CRGB(0, 0, 0);
  FastLED.show();
    leds[0] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 13) {
    leds[0] = CRGB(0, 0, 0);
  FastLED.show();
    leds[1] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 14) {
    leds[1] = CRGB(0, 0, 0);
  FastLED.show();
    leds[2] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 15) {
    leds[2] = CRGB(0, 0, 0);
  FastLED.show();
    leds[3] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 16) {
    leds[3] = CRGB(0, 0, 0);
  FastLED.show();
    leds[4] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 17) {
    leds[4] = CRGB(0, 0, 0);
  FastLED.show();
    leds[5] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 18) {
    leds[5] = CRGB(0, 0, 0);
  FastLED.show();
    leds[6] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 19) {
    leds[6] = CRGB(0, 0, 0);
  FastLED.show();
    leds[7] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 20) {
    leds[7] = CRGB(0, 0, 0);
  FastLED.show();
    leds[8] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 21) {
    leds[8] = CRGB(0, 0, 0);
  FastLED.show();
    leds[9] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 22) {
    leds[9] = CRGB(0, 0, 0);
  FastLED.show();
    leds[10] = CRGB(255, 0, 0);
  FastLED.show();
  }
  if(hour(t) == 23) {
    leds[10] = CRGB(0, 0, 0);
  FastLED.show();
   leds[11] = CRGB(255, 0, 0);
  FastLED.show();
  }
  
}

void minutering() {
  char bufm[40];
  time_t t = myRTC.get();
  sprintf(bufm, "%.2d ",
       minute(t));
  Serial.print(bufm);
  if(minute(t) == 05||minute(t) == 06||minute(t) == 07||minute(t) == 8||minute(t) == 9) {
    leds[0] = CRGB(0, 0, 0);
  FastLED.show();
    leds[1] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 10||minute(t) == 11||minute(t) == 12||minute(t) == 13||minute(t) == 14) {
    leds[1] = CRGB(0, 0, 0);
  FastLED.show();
    leds[2] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 15||minute(t) == 16||minute(t) == 17||minute(t) == 18||minute(t) == 19) {
    leds[2] = CRGB(0, 0, 0);
  FastLED.show();
    leds[3] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 20||minute(t) == 21||minute(t) == 22||minute(t) == 23||minute(t) == 24) {
    leds[3] = CRGB(0, 0, 0);
  FastLED.show();
    leds[4] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 25||minute(t) == 26||minute(t) == 27||minute(t) == 28||minute(t) == 29) {
    leds[4] = CRGB(0, 0, 0);
  FastLED.show();
    leds[5] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 30 || minute(t) == 31 || minute(t) == 32 || minute(t) == 33 || minute(t) == 34) {
    leds[5] = CRGB(0, 0, 0);
  FastLED.show();
    leds[6] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 35||minute(t) == 36||minute(t) == 37||minute(t) == 38||minute(t) == 39) {
    leds[6] = CRGB(0, 0, 0);
  FastLED.show();
    leds[7] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 40||minute(t) == 41||minute(t) == 42||minute(t) == 43||minute(t) == 44) {
    leds[7] = CRGB(0, 0, 0);
  FastLED.show();
    leds[8] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 45||minute(t) == 46||minute(t) == 47||minute(t) == 48||minute(t) == 49) {
    leds[8] = CRGB(0, 0, 0);
  FastLED.show();
    leds[9] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 50||minute(t) == 51||minute(t) == 52||minute(t) == 53||minute(t) == 54) {
    leds[9] = CRGB(0, 0, 0);
  FastLED.show();
    leds[10] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 55||minute(t) == 56||minute(t) == 57||minute(t) == 58||minute(t) == 59) {
    leds[10] = CRGB(0, 0, 0);
  FastLED.show();
   leds[11] = CRGB(0, 255, 0);
  FastLED.show();
  }
  if(minute(t) == 00||minute(t) == 01||minute(t) == 02||minute(t) == 03||minute(t) == 04) {
    leds[11] = CRGB(0, 0, 0);
  FastLED.show();
    leds[0] = CRGB(0, 255, 0);
  FastLED.show();
  }

}

void secondring() {
  char bufs[40];
  time_t t = myRTC.get();
  sprintf(bufs, "%.2d ",
       second(t));
  Serial.println(bufs);
  if(second(t) == 05||second(t) == 06||second(t) == 07||second(t) == 8||second(t) == 9) {
    leds[0] = CRGB(0, 0, 0);
  FastLED.show();
    leds[1] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 10||second(t) == 11||second(t) == 12||second(t) == 13||second(t) == 14) {
    leds[1] = CRGB(0, 0, 0);
  FastLED.show();
    leds[2] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 15||second(t) == 16||second(t) == 17||second(t) == 18||second(t) == 19) {
    leds[2] = CRGB(0, 0, 0);
  FastLED.show();
    leds[3] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 20||second(t) == 21||second(t) == 22||second(t) == 23||second(t) == 24) {
    leds[3] = CRGB(0, 0, 0);
  FastLED.show();
    leds[4] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 25||second(t) == 26||second(t) == 27||second(t) == 28||second(t) == 29) {
    leds[4] = CRGB(0, 0, 0);
  FastLED.show();
    leds[5] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 30 || second(t) == 31 || second(t) == 32 || second(t) == 33 || second(t) == 34) {
    leds[5] = CRGB(0, 0, 0);
  FastLED.show();
    leds[6] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 35||second(t) == 36||second(t) == 37||second(t) == 38||second(t) == 39) {
    leds[6] = CRGB(0, 0, 0);
  FastLED.show();
    leds[7] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 40||second(t) == 41||second(t) == 42||second(t) == 43||second(t) == 44) {
    leds[7] = CRGB(0, 0, 0);
  FastLED.show();
    leds[8] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 45||second(t) == 46||second(t) == 47||second(t) == 48||second(t) == 49) {
    leds[8] = CRGB(0, 0, 0);
  FastLED.show();
    leds[9] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 50||second(t) == 51||second(t) == 52||second(t) == 53||second(t) == 54) {
    leds[9] = CRGB(0, 0, 0);
  FastLED.show();
    leds[10] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 55||second(t) == 56||second(t) == 57||second(t) == 58||second(t) == 59) {
    leds[10] = CRGB(0, 0, 0);
  FastLED.show();
   leds[11] = CRGB(0, 0, 255);
  FastLED.show();
  }
  if(second(t) == 00||second(t) == 01||second(t) == 02||second(t) == 03||second(t) == 04) {
    leds[11] = CRGB(0, 0, 0);
  FastLED.show();
    leds[0] = CRGB(0, 0, 255);
  FastLED.show();
  }
  
}
